package com.alterdekim.flash.decompiler.compiler;

import com.alterdekim.flash.decompiler.tag.*;
import com.alterdekim.flash.decompiler.translator.Java2Flash;
import com.alterdekim.flash.decompiler.util.ByteUtil;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Queue;
import java.util.stream.Collectors;

@RequiredArgsConstructor
@Slf4j
public class FlashCompiler {
    private final Java2Flash pcode;

    public byte[] compile() {
        List<Byte> data = new ArrayList<>();
        data.addAll(List.of((byte) 0x46, (byte) 0x57, (byte) 0x53));
        data.add((byte) 0x08); // swf version (8)
        List<Byte> d1 = new ArrayList<>();
        d1.addAll(List.of((byte) 0x30, (byte) 0x0A, (byte) 0x00, (byte) 0xA0)); // rect
        d1.addAll(List.of((byte) 0x00, (byte) 0x19)); // frameRate
        d1.addAll(ByteUtil.intToBytes(1)); // frames Count
        //List<CompileObject> tags = List.of(new SetBackgroundColor(new byte[] {0,0,0}), new DoAction(pcode.getPool(), pcode.getActions()), new ShowFrame(), new End());
        //d1.addAll(tags.stream().map(CompileObject::compile).flatMap(Collection::stream).collect(Collectors.toList()));
        d1.addAll(new SetBackgroundColor(new byte[] {0,0,0}).compile());
        d1.addAll(new DoAction(pcode.getPool(), pcode.getActions()).compile());
        d1.addAll(new ShowFrame().compile());
        d1.addAll(new End().compile());
        // fileSize u32
        log.info("fileSize u32: {}", d1.size());
        data.addAll(ByteUtil.intToBytes32(d1.size()+data.size()+4));
        data.addAll(d1);
        return ByteUtil.toPrimitive(data);
    }
}
